/*
 *  TOPPERS/JSP Rose-RT Link Programs
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by CHUO ELECTRIC WORKS Co.,LTD. JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 */
/*
 *  ()ITRONSH1CPUܡ
 *  LED,SW ؿ
 */
#include <s_services.h>
#include <sh1_sil.h>
#include "zunda_sh1.h"
#include "device.h"

/*
 *  LEDν
 */
void
initial_led(void)
{
	set_led( LED1, OFF );
	set_led( LED2, OFF );
	set_led( LED3, OFF );
}

/*
 *  LEDԤ
 *  arg1: LED1 - 3
 *  arg2: ON|OFF
 */
void
set_led( int led, int req )
{
	if ( req != ON && req != OFF ) {
		return;
	}
	
	switch ( led ) {
	case LED1:
		if( req == OFF ) {
			sh1_orh_reg( PA_DR, LED_CTL1 );
		} else {
			sh1_anh_reg( PA_DR, ~LED_CTL1 );
		}
		break;
	case LED2:
		if( req == OFF ) {
			sh1_orh_reg( PB_DR, LED_CTL2 );
		} else {
			sh1_anh_reg( PB_DR, ~LED_CTL2 );
		}
		break;
	case LED3:
		if( req == OFF ) {
			sh1_orh_reg( PB_DR, LED_CTL3 );
		} else {
			sh1_anh_reg( PB_DR, ~LED_CTL3 );
		}
		break;
	default:
		break;
	}
}

/*
 *  LEDξּ
 *  arg1: LED1 - 3
 */
int
get_led( int led )
{
	switch ( led ) {
	case LED1:
		if ( (sil_reh_mem( PA_DR ) & LED_CTL1) == 0 ) {
			return ON;
		}
		break;
	case LED2:
		if ( (sil_reh_mem( PB_DR ) & LED_CTL2) == 0 ) {
			return ON;
		}
		break;
	case LED3:
		if ( (sil_reh_mem( PB_DR ) & LED_CTL3) == 0 ) {
			return ON;
		}
		break;
	default:
		break;
	}
	return OFF;
}

/*
 *  ǥåץåξּ
 *  return:ON OFF
 *  arg1:DSW11  DSW14
 */
int
get_dsw( int sw )
{
	UH	key = 0;
	int	result = OFF;

	key = sil_reh_mem( SW_DR );
	switch ( sw ) {
	case DSW11:
		if ((key & DSW11) == 0 ) {
			result = ON;
		}
		break;
	case DSW12:
		if ((key & DSW12) == 0 ) {
			result = ON;
		}
		break;
	case DSW13:
		if ((key & DSW13) == 0 ) {
			result = ON;
		}
		break;
	case DSW14:
		if ((key & DSW14) == 0 ) {
			result = ON;
		}
		break;
	default:
		break;
	}
	return result;
}

/*
 *  ꡼åͼ
 *  return:å
 */
int
get_rsw(void)
{
	return (sil_reh_mem( SW_DR ) & RSW_CTL);
}

